<?php
// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once OCC_COUNTRY_FILE;

// Get topics
$topq = "SELECT * FROM `" . OCC_TABLE_TOPIC . "`";
if ($OC_configAR['OC_topicDisplayAlpha']) { 
	$topq .= " ORDER BY `topicname`";
}
$topr = ocsql_query($topq) or err('unable to retrieve topics');
if (($tnum = mysql_num_rows($topr)) < 1) {
	warn(oc_('We are still waiting for the Chair to finalize the list of topics before opening up for submissions.  Please check back later.'));
} else {
	$topicAR = array();
	while ($topl = mysql_fetch_assoc($topr)) {
		$topicAR[$topl['topicid']] = $topl['topicname'];
	}
}

// See include-forms.inc for syntax format

$OC_submissionFieldAR = array();
$OC_submissionFieldSetAR = array();

// General Info
$OC_submissionFieldAR['title'] = array(
	'name' => oc_('Submission Title'),
	'short' => oc_('Title'),
	'note' => '',
	'type' => 'text',
	'size' => 80,
	'maxsize' => 250,
	'required' => TRUE,	// always required
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_general'] = array(
	'fieldset' => oc_('General Information'),
	'note' => '',
	'fields' => array('title')
);

if ($OC_configAR['OC_trackStudent'] == 1) {
	$OC_submissionFieldAR['student'] = array(
		'name' => oc_('Student'),
		'short' => oc_('Student'),
		'note' => $GLOBALS['OC_configAR']['OC_studentNote'],
		'type' => 'radio',
		'usekey' => TRUE,
		'required' => TRUE,	// always required
		'delimiter' => ' &nbsp; ',
		'values' => array('T' => oc_('Yes'), 'F' => oc_('No'))
	);
	
	$OC_submissionFieldSetAR['fs_general']['fields'][] = 'student';
}

// Authors
$OC_submissionFieldAR['honorific'] = array(
	'name' => oc_('Honorific'),
	'short' => oc_('Honorific'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 60,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['name_first'] = array(
	'name' => oc_('First/Given Name'),
	'short' => oc_('First Name'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 60,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['name_last'] = array(
	'name' => oc_('Last/Family Name'),
	'short' => oc_('Last Name'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 40,
	'required' => TRUE,	// always required
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['suffix'] = array(
	'name' => oc_('Suffix'),
	'short' => oc_('Suffix'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 60,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['position_title'] = array(
	'name' => oc_('Position/Title'),
	'short' => oc_('Position'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['organization'] = array(
	'name' => oc_('Organization'),
	'short' => oc_('Organization'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 250,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['department'] = array(
	'name' => oc_('Department/Division'),
	'short' => oc_('Department/Division'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['address'] = array(
	'name' => oc_('Address'),
	'short' => oc_('Address'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['address2'] = array(
	'name' => oc_('Address 2'),
	'short' => oc_('Address 2'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['city'] = array(
	'name' => oc_('City'),
	'short' => oc_('City'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['spc'] = array(
	'name' => oc_('State/Province'),
	'short' => oc_('State/Province'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 255,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['postcode'] = array(
	'name' => oc_('Postcode/Zip'),
	'short' => oc_('Postcode/Zip'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 100,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['country'] = array(
	'name' => oc_('Country'),
	'short' => oc_('Country'),
	'note' => '',
	'type' => 'select',
	'blank' => true,
	'required' => FALSE,
	'usekey' => TRUE,
	'values' => $GLOBALS['OC_countryAR']
);

$OC_submissionFieldAR['email'] = array(
	'name' => oc_('Email'),
	'short' => oc_('Email'),
	'note' => '',
	'type' => 'text',
	'maxsize' => 100,
	'required' => FALSE,	// required for contact author automatically
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_authors'] = array(
	'fieldset' => oc_('Author(s)'),
	'note' => '',
	'fields' => array('honorific', 'name_first', 'name_last', 'suffix', 'position_title', 'organization', 'department', 'address', 'address2', 'city', 'spc', 'postcode', 'country', 'email')
);

// Other Authors
if (isset($_POST['otherauthors']) && !empty($_POST['otherauthors'])) {
	$OC_submissionFieldAR['otherauthors'] = array(
		'name' => oc_('Other Authors'),
		'short' => oc_('Other Authors'),
		'note' => '',
		'type' => 'textarea',
		'required' => FALSE,
		'size' => 7,
		'usekey' => FALSE,
		'values' => ''
	);
	
	$OC_submissionFieldSetAR['fs_otherauthors'] = array(
		'fieldset' => oc_('Other Authors'),
		'note' => '',
		'fields' => array('otherauthors')
	);
}

// Contact Author
$OC_submissionFieldAR['contactid'] = array(
	'name' => oc_('Contact Author'),
	'short' => oc_('Contact Author'),
	'note' => oc_('Author who will serve as the point of contact for correspondence about the submission.'),
	'type' => 'select',
	'required' => TRUE,	// always required
	'usekey' => TRUE,
	'values' => array()
);

$OC_submissionFieldAR['altcontact'] = array(
	'name' => oc_('Alternate Contact'),
	'short' => oc_('Alternate Contact'),
	'note' => oc_('Alternate contact information, such as personal email address or telephone number; used only if unable to contact using above email address.'),
	'type' => 'text',
	'maxsize' => 100,
	'required' => TRUE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_contactauthor'] = array(
	'fieldset' => oc_('Contact Author'),
	'note' => '',
	'fields' => array('contactid', 'altcontact')
);
for ($i=1; $i<=$GLOBALS['oc_authorNum']; $i++) {
	$OC_submissionFieldAR['contactid']['values'][$i] = oc_('Author') . ' ' . $i;  // oc_ only around Author because of JS in include-forms
}

// Topics
if (count($topicAR) > 1) {
	$OC_submissionFieldAR['topics'] = array(
		'name' => oc_('Topic Areas'),
		'short' => oc_('Topic(s)'),
		'note' => '',
		'type' => ($OC_configAR['OC_multipleSubmissionTopics'] ? 'checkbox' : 'radio'),
		'usekey' => TRUE,
		'required' => TRUE,	// always required
		'values' => $topicAR
	);
	
	$OC_submissionFieldSetAR['fs_topics'] = array(
		'fieldset' => oc_('Topic Areas'),
		'note' => oc_n('To help match submissions to reviewers and sessions, please select one area most applicable to your submission', 'To help match submissions to reviewers and sessions, please select one or more area(s) most applicable to your submission', ($OC_configAR['OC_multipleSubmissionTopics'] + 1)),
		'fields' => array('topics')
	);
} else { // single topic
	$OC_submissionFieldAR['topics'] = array(
		'name' => oc_('Topic Area'),
		'short' => oc_('Topic'),
		'note' => '',
		'required' => TRUE,	// always required
		'type' => 'plain',
		'values' => safeHTMLstr(current($topicAR)) . '<input type="hidden" name="topics[]" value="' . key($topicAR) . '" />'
	);
	
	$OC_submissionFieldSetAR['fs_topics'] = array(
		'fieldset' => oc_('Topic Areas'),
		'note' => '',
		'fields' => array('topics')
	);
}

// Content
$OC_submissionFieldAR['keywords'] = array(
	'name' => oc_('Keywords'),
	'short' => oc_('Keywords'),
	'note' => '',
	'type' => 'text',
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['abstract'] = array(
	'name' => oc_('Abstract'),
	'short' => oc_('Abstract'),
	'note' => (($OC_configAR['OC_abstractLength'] > 0) ? (sprintf(oc_('Abstract length is limited to %d words.'), $OC_configAR['OC_abstractLength'])) : ''),
	'type' => 'textarea',
	'size' => 10,
	'required' => FALSE,
	'maxsize' => $OC_configAR['OC_abstractLength'],
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_content'] = array(
	'fieldset' => oc_('Content'),
	'note' => '',
	'fields' => array('keywords', 'abstract')
);

if ($OC_configAR['OC_includeSubmissionUploadField'] && preg_match("/submit/", $_SERVER['PHP_SELF'])) {	 // only display file fields if submission & enabled by Chair
	$OC_submissionFieldAR['fileblank'] = array(
		'name' => '',
		'short' => '',
		'note' => '',
		'type' => 'plain',
		'usekey' => FALSE,
		'values' => '&nbsp;'
	);
	$OC_submissionFieldSetAR['fs_content']['fields'][] = 'fileblank';
	
	$OC_submissionFieldAR['file'] = array(
		'name' => oc_('File'),
		'short' => oc_('File'),
		'note' => '',
		'type' => 'file',
		'usekey' => FALSE,
		'values' => ''
	);
	$OC_submissionFieldSetAR['fs_content']['fields'][] = 'file';
	
	$OC_submissionFieldAR['format'] = array(
		'name' => oc_('File Format'),
		'short' => oc_('File Format'),
		'note' => '<span class="note3">' . $GLOBALS['fileNotice'] . '</span><br />' . sprintf(oc_('File upload limit through this form is %s.'),  $GLOBALS['OC_maxFileSize'])
	);
	$OC_submissionFieldSetAR['fs_content']['fields'][] = 'format';
	
	if (count($GLOBALS['extAR']) == 1) {  // Only accept one format?
		$OC_submissionFieldAR['format']['type'] = 'plain';
		$OC_submissionFieldAR['format']['values'] = sprintf(oc_('%s only'), $GLOBALS['OC_formatAR'][$GLOBALS['extAR'][0]]) . ' <input type="hidden" name="format" value="' . $GLOBALS['extAR'][0] . '">';
		$OC_submissionFieldAR['format']['usekey'] = FALSE;
	} else {
		$formatOptions = array();
		foreach ($GLOBALS['extAR'] as $formatVal) {
			$formatOptions[$formatVal] = $GLOBALS['OC_formatAR'][$formatVal];
		}
		$OC_submissionFieldAR['format']['type'] = 'select';
		$OC_submissionFieldAR['format']['values'] = $formatOptions;
		$OC_submissionFieldAR['format']['usekey'] = TRUE;
	}

} // if OC_includeSubmissionUploadField

// Password
$OC_submissionFieldAR['password1'] = array(
	'name' => oc_('Password'),
	'short' => oc_('Password'),
	'note' => '',
	'type' => 'password',
	'required' => TRUE,	// always required
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldAR['password2'] = array(
	'name' => oc_('Re-enter Password'),
	'short' => oc_('Confirm'),
	'note' => '',
	'type' => 'password',
	'required' => TRUE,	// always required
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_passwords'] = array(
	'fieldset' => oc_('Password'),
	'note' => oc_('Please enter a password you will remember. The submission ID, which you will receive via email upon submission of this form, along with this password will allow you to make future changes to this submission.'),
	'fields' => array('password1', 'password2')
);

// Comments
$OC_submissionFieldAR['comments'] = array(
	'name' => oc_('Optional Comments'),
	'short' => oc_('Comments'),
	'note' => '',
	'type' => 'textarea',
	'size' => 5,
	'required' => FALSE,
	'usekey' => FALSE,
	'values' => ''
);

$OC_submissionFieldSetAR['fs_comments'] = array(
	'fieldset' => oc_('Comments'),
	'note' => '',
	'fields' => array('comments')
);

// Unset fields that should not be displayed on form
if (!empty($GLOBALS['OC_configAR']['OC_hideSubFields'])) {
	$hSF = explode(',', $GLOBALS['OC_configAR']['OC_hideSubFields']);
	foreach ($hSF as $hs_f) {
		list($a_fs, $a_f) = explode(':', $hs_f);
		unset($OC_submissionFieldAR[$hs_f]);
		if (in_array($a_f, $OC_submissionFieldSetAR[$a_fs]['fields'])) {
			$OC_submissionFieldSetAR[$a_fs]['fields'] = array_diff($OC_submissionFieldSetAR[$a_fs]['fields'], array($a_f));
		}
	}
}

if (oc_hookSet('author-submission-inc')) {
	foreach ($GLOBALS['OC_hooksAR']['author-submission-inc'] as $v) {
		require_once $v;
	}
}

