<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("Files Directory",1);

$skipAR = array('.','..','index.html','.htaccess');

$dir = $OC_configAR['OC_paperDir'];
$linkParams = 'c=1';

if (oc_hookSet('chair-list_files-preprocess')) {
	foreach ($GLOBALS['OC_hooksAR']['chair-list_files-preprocess'] as $hook) {
		require_once $hook;
	}
}
	
if ($pdh = opendir($dir)) {
	$fAR = array();
	while(($f = readdir($pdh)) !== false) {
		if (is_file($dir.$f) && !in_array($f,$skipAR)) {
		    array_push($fAR,$f);
		}
	}
	closedir($pdh);

	if (oc_hookSet('chair-list_files')) {
		foreach ($GLOBALS['OC_hooksAR']['chair-list_files'] as $hook) {
			require_once $hook;
		}
	}
	
	if (count($fAR) > 0) {
		sort($fAR,SORT_NUMERIC);
		print '<table border=0 cellspacing=1 cellpadding=4><tr class="rowheader"><th>File</th><th>Size</th><th>Last Updated</th></tr>';
		$row = 1;
		foreach ($fAR as $f) {
			print '<tr class="row' . $row . '"><td><a href="../review/paper.php?' . $linkParams . '&p=' . $f . '" target="paper">' . $f . '</a></td><td align="right">' . oc_formatNumber(oc_fileSize($dir.$f)) . '</td><td>' . date("d M Y H:i:s", oc_fileMtime($dir.$f)) . "</td></tr>\n";
			$row = $rowAR[$row];
		}
		print "</table>\n";
	} else { // 0 files
		print '<p><span class="warn">No files found</span></p>';
	}
} else {
	print '<p><span class="warn">Unable to open files directory</span></p>';
}

printFooter();

?>
