<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

if (isset($_REQUEST['cmt']) && ($_REQUEST['cmt'] == "rev")) {
	$cmtAdd = " WHERE `onprogramcommittee`='F'";
	$hdr = "Review Committee Members";
} elseif (isset($_REQUEST['cmt']) && ($_REQUEST['cmt'] == "pc")) {
	$cmtAdd = " WHERE `onprogramcommittee`='T'";
	$hdr = "Program Committee Members";
} else {
	$cmtAdd = '';
	$hdr = "Review &amp; Program Committee Members";
	$_REQUEST['cmt'] = '';
}

printHeader($hdr,1);

if (isset($_POST['faction']) && isset($_POST['drop']) && !empty($_POST['drop'])) {
	// Check for valid submission
	if (!validToken('chair')) {
		warn('Invalid submission');
	}
	
	if  ($_POST['faction'] == "Delete Members") {	// delete members
		foreach ($_POST['drop'] as $val) {
			if (preg_match("/^\d+$/", $val)) {
				issueSQL("DELETE FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `advocateid`='" . safeSQLstr($val) . "'");
				issueSQL("DELETE FROM `" . OCC_TABLE_PAPERREVIEWER . "` WHERE `reviewerid`='" . safeSQLstr($val) . "'");
				issueSQL("DELETE FROM `" . OCC_TABLE_REVIEWERTOPIC . "` WHERE `reviewerid`='" . safeSQLstr($val) . "'");
				issueSQL("DELETE FROM `" . OCC_TABLE_PAPERSESSION . "` WHERE `reviewerid`='" . safeSQLstr($val) . "'");
				issueSQL("DELETE FROM `" . OCC_TABLE_REVIEWER . "` WHERE `reviewerid`='" . safeSQLstr($val) . "'");
			}
		}
	} elseif  ($_POST['faction'] == "Add to PC") {	// add to program committee
		foreach ($_POST['drop'] as $val) {
			if (preg_match("/^\d+$/", $val)) {
				issueSQL("UPDATE " . OCC_TABLE_REVIEWER . " SET `onprogramcommittee`='T' WHERE `reviewerid`='" . safeSQLstr($val) . "' LIMIT 1");
			}
		}
	} elseif  ($_POST['faction'] == "Remove from PC") {	// remove from program committee
		foreach ($_POST['drop'] as $val) {
			if (preg_match("/^\d+$/", $val)) {
				issueSQL("DELETE FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `advocateid`='" . safeSQLstr($val) . "'");
				issueSQL("UPDATE `" . OCC_TABLE_REVIEWER . "` SET `onprogramcommittee`='F' WHERE `reviewerid`='" . safeSQLstr($val) . "' LIMIT 1");
			}
		}
	}
}

if (!isset($_REQUEST['s']) || ($_REQUEST['s'] == "id")) {
	$sortby = "reviewerid";
	$rsortstr = 'ID<br />' . $OC_sortImg;
	$pcsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=pc&cmt=' . $_REQUEST['cmt'] . '">PC</a>';
	$nsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=name&cmt=' . $_REQUEST['cmt'] . '">Name</a>';
} elseif ($_REQUEST['s'] == "pc") {
	$sortby = "onprogramcommittee, name_last, name_first";
	$pcsortstr = 'PC<br />' . $OC_sortImg;
	$rsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=id&cmt=' . $_REQUEST['cmt'] . '">ID</a>';
	$nsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=name&cmt=' . $_REQUEST['cmt'] . '">Name</a>';
} else {	// name sort
	$sortby = "name_last, name_first";
	$nsortstr = 'Name<br />' . $OC_sortImg;
	$rsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=id&cmt=' . $_REQUEST['cmt'] . '">ID</a>';
	$pcsortstr = '<a href="'.$_SERVER['PHP_SELF'].'?s=pc&cmt=' . $_REQUEST['cmt'] . '">PC</a>';
}

$q = "SELECT `reviewerid`, CONCAT_WS(' ',`name_first`,`name_last`) AS `name`, `username`, `email`, `onprogramcommittee`, `comments` FROM `" . OCC_TABLE_REVIEWER . "` $cmtAdd ORDER BY $sortby";
$r = ocsql_query($q) or err("Unable to get information");
if (mysql_num_rows($r) == 0) {
	print '<span class="warn">No committee members have signed up yet</span><p>';
} else {
	print "Count: ".mysql_num_rows($r)."<p>\n";

	print '
	<span class="note">Note: If you choose to delete committee member(s), any records of papers assigned to them for review or advocacy will also be deleted.</span><p>
	<form method="post" action="' . $_SERVER['PHP_SELF'] . '">
	<input type="hidden" name="token" value="' . $_SESSION[OCC_SESSION_VAR_NAME]['chairtoken'] . '" />
	<input type="hidden" name="cmt" value="' . safeHTMLstr($_REQUEST['cmt']) . '" />
';
	if (isset($_REQUEST['s'])) {
		print '<input type="hidden" name="s" value="' . safeHTMLstr($_REQUEST['s']) . '" />';
	}
	print '
	<table border=0 cellpadding=5 cellspacing=0 bgcolor="#ccccff"><tr><td><input type="submit" name="faction" value="Delete Members" onclick="return confirm(\'Delete all checked member(s) data?\')" />';
	if ($OC_configAR['OC_paperAdvocates']) {
		print ' &nbsp; &nbsp; <input type="submit" name="faction" value="Add to PC" /> &nbsp; &nbsp; <input type="submit" name="faction" value="Remove from PC" onclick="return confirm(\'Delete checked member(s) advocacy data?\')" />';
	}
	print '</td></tr></table>

	<table border=0 cellspacing=1 cellpadding=4>
	<tr class="rowheader"><th class="del">&nbsp;</th><th>' . $rsortstr . '</th>';
	if (empty($_REQUEST['cmt'])) {
		print '<th>' . $pcsortstr . '</th>';
	}		
	print '<th>' . $nsortstr . '</th><th>Username</th><th>Comments</th></tr>
	';
	$row = 1;
	while ($l = mysql_fetch_array($r)) {
	  	print '<tr class="row' . $row . '"><td class="del"><input type="checkbox" name="drop[]" value="' . $l['reviewerid'] . '"></td><td align="right">' . $l['reviewerid'] . '</td>';
		if (empty($_REQUEST['cmt'])) {
			print '<td>';
	  		if ($l['onprogramcommittee'] == 'T') {
    			print "<img src=\"../images/check.gif\" alt=\"PC Member\" title=\"PC Member\" width=16 height=17>";
			} else {
  				print "&nbsp;";
	  		}
	  		print '</td>';
		}
		print '<td><a href="show_reviewer.php?rid='.$l['reviewerid'].'">' . safeHTMLstr($l['name']) . '</a></td><td>'.$l['username'].'</td><td>' . safeHTMLstr($l['comments']) . " &nbsp;</td></tr>\n";
		if ($row==1) { $row=2; } else { $row=1; }
}
	print '
	</table>
	<table border=0 cellpadding=5 cellspacing=0 bgcolor="#ccccff"><tr><td><input type="submit" name="faction" value="Delete Members" onclick="return confirm(\'Delete all checked member(s) data?\')" />';
	if ($OC_configAR['OC_paperAdvocates']) {
		print ' &nbsp; &nbsp; <input type="submit" name="faction" value="Add to PC" /> &nbsp; &nbsp; <input type="submit" name="faction" value="Remove from PC" onclick="return confirm(\'Delete checked member(s) advocacy data?\')" />';
	}
	print '</td></tr></table>
	</form>
	';
}

printFooter();

?>
