<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

beginChairSession();

printHeader("At-a-Glance Summary",1);

// Get count of papers
$r = ocsql_query("SELECT COUNT(`" . OCC_TABLE_PAPER . "`.`paperid`) AS `papertotal` FROM " . OCC_TABLE_PAPER) or err("Unable to query submission info");
$l = mysql_fetch_array($r);
$l1['papertotal'] = $l['papertotal'];

// Get count of withdrawn submissions
$r = ocsql_query("SELECT COUNT(*) AS `withdrawtotal` FROM `" . OCC_TABLE_WITHDRAWN . "`") or err("Unable to query withdrawn submission info");
$l = mysql_fetch_assoc($r);
$l1['withdrawtotal'] = $l['withdrawtotal'];

// Get count of reviews
$r = ocsql_query("SELECT COUNT(*) AS `reviewstotal` FROM `" . OCC_TABLE_PAPERREVIEWER . "`") or err("Unable to query reviews info");
$l = mysql_fetch_array($r);
$l1['reviewstotal'] = $l['reviewstotal'];

// Get # of papers w/reviewers assigned
$r = ocsql_query("SELECT COUNT(DISTINCT(`paperid`)) AS `revassigned` FROM `" . OCC_TABLE_PAPERREVIEWER . "`") or err("Unable to query assigned count");
$l = mysql_fetch_array($r);
$l1['revassigned'] = $l['revassigned'];

// Get count of advocate assignments
$r = ocsql_query("SELECT COUNT(*) AS `advocatingtotal` FROM `" . OCC_TABLE_PAPERADVOCATE . "`") or err("Unable to query advocate assignment info");
$l = mysql_fetch_array($r);
$l1['advocatingtotal'] = $l['advocatingtotal'];

// Get # of uploads
$uploadtotal = oc_fileCount($OC_configAR['OC_paperDir']);

// Get count of signed up reviewers, advocates
$r = ocsql_query("SELECT `" . OCC_TABLE_REVIEWER . "`.`onprogramcommittee`, COUNT(`" . OCC_TABLE_REVIEWER . "`.`reviewerid`) AS `count` FROM `" . OCC_TABLE_REVIEWER . "` GROUP BY `" . OCC_TABLE_REVIEWER . "`.`onprogramcommittee`") or err("Unable to query reviewer info");
$rcount = array();
$rcount['T'] = 0;
$rcount['F'] = 0;
while ($l = mysql_fetch_array($r)) {
	$rcount[$l['onprogramcommittee']] = $l['count'];
}
// Get count of pc decision
$r = ocsql_query("SELECT `" . OCC_TABLE_PAPER . "`.`accepted`, COUNT(`" . OCC_TABLE_PAPER . "`.`paperid`) AS `count` FROM `" . OCC_TABLE_PAPER . "` GROUP BY `" . OCC_TABLE_PAPER . "`.`accepted`") or err("Unable to query submission info");
$pcount = array();
$pcount['T'] = 0;
$pcount['F'] = 0;
while ($l = mysql_fetch_array($r)) {
	$pcount[$l['accepted']] = $l['count'];
}
// Get count of completed reviews
$r = ocsql_query("SELECT COUNT(`" . OCC_TABLE_PAPERREVIEWER . "`.`paperid`) FROM `" . OCC_TABLE_PAPERREVIEWER . "` WHERE `" . OCC_TABLE_PAPERREVIEWER . "`.`completed`='T'") or err("Unable to query reviews");
$l = mysql_fetch_row($r);
$reviewscompleted = $l[0];
// Get count of advocate recommendations
$r = ocsql_query("SELECT COUNT(`" . OCC_TABLE_PAPERADVOCATE . "`.`paperid`) FROM `" . OCC_TABLE_PAPERADVOCATE . "` WHERE `" . OCC_TABLE_PAPERADVOCATE . "`.`adv_recommendation` IS NOT NULL") or err("Unable to query recommendations");
$l = mysql_fetch_row($r);
$advocaterecommendations = $l[0];
// Get acceptance type
$r = ocsql_query("SELECT `accepted`, COUNT(*) AS `count` FROM `" . OCC_TABLE_PAPER . "` GROUP BY `accepted`") or err("Unable to get score count");
$accCountAR = array();
while ($l = mysql_fetch_array($r)) {
	if (empty($l['accepted'])) {
		$accCountAR['Pending'] = $l['count'];
	} else {
		$accCountAR[$l['accepted']] = $l['count'];
	}
}

print '
<style type="text/css">
#summary dt { margin-top: 1.5em; margin-bottom: 0.5em;}
#summary .summhdr { font-weight: bold; }
</style>
<dl id="summary">
<dt><span class="summhdr">Submissions:</span> (<em>new - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_submissions_open']] . '</a> &#8226; edit - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_edit_open']] . '</a> &#8226; upload - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_upload_open']] . '</a> &#8226; view file - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_view_file_open']] . '</a></em>)</dt>
	<dd><a href="list_papers.php">Total</a>: ' . $l1['papertotal'] . '</dd>
	<dd><a href="list_paper_dir.php">Files</a><span class="note">&sup1;</span>: ' . $uploadtotal . '</dd>
	<dd><a href="list_reviews.php">Rev.Assigned</a><span class="note">&sup2;</span>: ' . $l1['revassigned'] . '</dd>
';

// iterate through acceptance values
foreach ($OC_acceptanceValuesAR as $acc) {
	print '<dd><a href="list_scores.php">' . safeHTMLstr($acc['value']) . '</a>: ' . (isset($accCountAR[$acc['value']]) ? $accCountAR[$acc['value']] : '0') . "</dd>\n";
}

print '
	<dd><a href="list_scores.php">Pending</a>: ' . (isset($accCountAR['Pending']) ? $accCountAR['Pending'] : '0') . '</dd>
	<dd><a href="list_papers.php#withdrawn">Withdrawn</a>: ' . $l1['withdrawtotal'] . '</dd>
	<dd><p class="note">
&sup1; Quick count of files named "number.ext" in the default file upload directory.<br />
&sup2; Number of submissions with at least one reviewer assigned.
	</p></dd>

<dt><span class="summhdr">Reviewers:</span> (<em>sign up - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_rev_signup_open']] . '</a> &#8226; sign in - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_rev_signin_open']] . '</a></em>)</dt>
	<dd><a href="list_reviewers.php?cmt=rev">Signed up</a>' . ($OC_configAR['OC_paperAdvocates'] ? '<span class="note">&sup1;</span>' : '') . ': ' . $rcount['F'] . '</dd>
	<dd><a href="list_reviews.php">Assignments</a>: ' . $l1['reviewstotal'] . '</dd>
	<dd><a href="list_reviews.php">Completed</a>: ' . $reviewscompleted . '</dd>
';

if ($OC_configAR['OC_paperAdvocates']) {
	print '
	<dd><p class="note">
&sup1; Number of registered reviewers; does not include advocates who may also be assigned as reviewers.
	</p></dd>
<dt><span class="summhdr">Advocates:</span> (<em>sign up - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_pc_signup_open']] . '</a> &#8226; sign in - <a href="set_status.php">' . $OC_statusValueAR[$OC_statusAR['OC_pc_signin_open']] . '</a></em>)</dt>
	<dd><a href="list_reviewers.php?cmt=pc">Signed up</a>: ' . $rcount['T'] . '</dd>
	<dd><a href="list_advocates.php">Assignments</a>: ' . $l1['advocatingtotal'] . '</dd>
	<dd><a href="list_advocates.php">Recommendations</a>: ' . $advocaterecommendations . '</dd>
	';
}

if (oc_hookSet('chair-summary')) {
	foreach ($OC_hooksAR['chair-summary'] as $v) {
		include_once $v;
	}
}

print '
</dl>
<p />
';

printFooter();

?>
