<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";
require_once OCC_REVIEW_INC_FILE;

beginSession();

printHeader(oc_('Reviews'), 2);

if (!isset($_GET['pid']) || !preg_match("/^\d+$/",$_GET['pid'])) {
	warn(oc_('Submission ID is invalid.'));
}

print '<p style="text-align: center; font-weight: bold">' . sprintf(oc_('Submission ID %s'), safeHTMLstr($_GET['pid'])) . '</p>';

// Warn if conflict
$conflictAR = getConflicts($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid']);
if (in_array($_GET['pid'] . '-' . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'], $conflictAR)) {
	warn(oc_('You appear to have a conflict with this submission'));
}

// Check whether review assigned/completed?
$assigned = 0;
$completed = 0;
$q = "SELECT paperid, recommendation, completed FROM " . OCC_TABLE_PAPERREVIEWER . " WHERE paperid=" . $_GET['pid'] . " AND reviewerid=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
$r = ocsql_query($q) or err("Unable to check reviewer permissions " . mysql_errno());
if (mysql_num_rows($r) == 1) {
  	$assigned = 1;
  	$l = mysql_fetch_array($r);
  	if ($l['recommendation'] && ($l['completed'] == 'T')) { $completed = 1; }
}

$ok = 0;
// Check that reviewer has permission
if (!$assigned && $OC_configAR['OC_reviewerSeeOtherReviews']) {
	$ok = 1;
} elseif ($assigned && $OC_configAR['OC_reviewerSeeAssignedReviews']) {    // make sure reviewer is assigned
	if (!$OC_configAR['OC_reviewerCompleteBeforeSAR'] || $completed) {     // and doesn't hinge on completed review
		$ok = 1;
	}
}
// If not ok, check if advocate & has permission
if (!$ok && $_SESSION[OCC_SESSION_VAR_NAME]['acpc'] == "T") {
	if ($OC_configAR['OC_advocateSeeOtherReviews']) {
		$ok = 1;
	} else { // make sure advocate is assigned
		$q = "SELECT paperid FROM " . OCC_TABLE_PAPERADVOCATE . " WHERE paperid=" . $_GET['pid'] . " AND advocateid=" . $_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'];
		$r = ocsql_query($q) or err("Unable to check advocate permissions " . mysql_errno());
		if (mysql_num_rows($r) == 1) {
 			$ok = 1;
		}
	}
}
if (!$ok) {
	warn(oc_('You do not have permission to see the reviews for this submission'));
}

if ($OC_configAR['OC_reviewerSeeOtherReviewers'] && $assigned && ($emailList = getPaperReviewersEmail($_GET['pid']))) {
	print '<p style="text-align: center"><a href="mailto:' . $emailList . '">' . oc_('Email Reviewers') . '</a></p>';
}

// Display reviews
$q = "SELECT " . OCC_TABLE_PAPERREVIEWER . ".*, CONCAT_WS(' '," . OCC_TABLE_REVIEWER . ".name_first," . OCC_TABLE_REVIEWER . ".name_last) as name FROM " . OCC_TABLE_PAPERREVIEWER . ", " . OCC_TABLE_REVIEWER . " WHERE " . OCC_TABLE_PAPERREVIEWER . ".paperid='".$_GET['pid']."' AND " . OCC_TABLE_PAPERREVIEWER . ".reviewerid=" . OCC_TABLE_REVIEWER . ".reviewerid";
$r = ocsql_query($q) or err("Unable to get information ".mysql_errno());
if (mysql_num_rows($r) == 0) {
	warn(oc_('No reviews found'));
}
displayReviews($_GET['pid'], $r);

printFooter();

?>
