<?php

// +----------------------------------------------------------------------+
// | OpenConf                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2011 Zakon Group LLC.  All Rights Reserved.       |
// +----------------------------------------------------------------------+
// | This source file is subject to the OpenConf License, available on    |
// | the OpenConf web site: www.OpenConf.com                              |
// +----------------------------------------------------------------------+

require_once "../include.php";

if (isset($_SESSION[OCC_SESSION_VAR_NAME]['acreviewerid'])) {
	printHeader(oc_('Committee Signup'), 3);
	warn(sprintf(oc_('You already appear to be signed into a committee account.  Please <a href="%s">sign out</a> first before trying to create a new account.'), 'signout.php'));
	printFooter();
	exit;
}

oc_sendNoCacheHeaders();

require_once OCC_FORM_INC_FILE;
require_once OCC_COMMITTEE_INC_FILE;

// Verify keycode
if ($OC_configAR['OC_paperAdvocates'] && isset($_POST['keycode']) && ($_POST['keycode'] == $OC_configAR['OC_keycode_program'])) {
	printHeader(oc_('Program Committee Signup'), 3);
	if (! $OC_statusAR['OC_pc_signup_open']) { 
			warn(oc_('Committee sign-up is closed'));
	}
	$committee = "program";
	$committeeTrans = oc_('Program Committee');
	$oncommittee = "T";
}
elseif (isset($_POST['keycode']) && ($_POST['keycode'] == $OC_configAR['OC_keycode_reviewer'])) {
	printHeader(oc_('Reviewer Committee Signup'), 3);
	if (! $OC_statusAR['OC_rev_signup_open']) {
		warn(oc_('Committee sign-up is closed'));
	}
	$committee = "reviewer";
	$committeeTrans = oc_('Review Committee');
	$oncommittee = "F";
} else {
	printHeader(oc_('Committee Sign-Up'), 3);
	warn(oc_('The keycode entered is incorrect.  Please click on the Back button to try again.  If you are still unable to access the committee sign up page, please contact the Chair.'));
}

if (isset($_POST['ocaction']) && ($_POST['ocaction'] == "Submit Form")) {
	$err = '';
	$qfields = array();
	$tfields = array();

	require_once 'committee-validate.inc';

	if (!empty($err)) {
		print '<div class="warn">' . oc_('Please check the following:') . '<ul>' . $err . '</ul></div>';
	} else { // let's submit
		$q = "INSERT INTO `" . OCC_TABLE_REVIEWER . "` SET `onprogramcommittee`='" . $oncommittee . "'";
		foreach ($qfields as $qid => $qval) {
			$q .= ", `" . $qid . "`=" . $qval;
		}
		$r = ocsql_query($q) or err("unable to submit form");
		$rid = mysql_insert_id() or err("unable to get reviewer id");

	    // add topic(s)
		if (!empty($tfields)) {
			$q = "INSERT INTO `" . OCC_TABLE_REVIEWERTOPIC . "` (`reviewerid`,`topicid`) VALUES";
			foreach ($tfields as $t) {
				$q .= " ($rid,$t),";
			}
			$r = ocsql_query(rtrim($q, ',')) or err("unable to add reviewer topic, but account created ");
		}

		$confirmmsg = '
<p>' . oc_('Thank you for signing up.   We have emailed you a confirmation with your information.') . '</p>
<p>' . 
//T: Use care when translating the href - "mailto" and "subject" are not translated.  %2%s = event short name (e.g., CONF2012)
sprintf(oc_('If you have any questions, please contact the <a href="mailto:%1$s?subject=%2$s Committee Sign Up Question">Chair</a>'), $OC_configAR['OC_pcemail'], $OC_configAR['OC_confName']) . '</p>
';

		//T: %1$s = conference short name (e.g., CONF2012); %2$s = ["Program Committee" or "Review Committee"]; %3$s = chair email address
		$mailbody = sprintf(oc_('Thank you for signing up for the %1$s %2$s.  Below is the information you provided.  If you have any questions, please contact %3$s or reply to this email.'), $OC_configAR['OC_confName'], $committeeTrans, $OC_configAR['OC_pcemail']) . '

Reviewer ID: ' . $rid . "\n\n";
		$mailbody .= oc_genFieldMessage($OC_reviewerFieldSetAR, $OC_reviewerFieldAR, $_POST);

		if (oc_hookSet('committee-signup-add')) {
			foreach ($GLOBALS['OC_hooksAR']['committee-signup-add'] as $hook) {
				require_once $hook;
			}
		}

		print $confirmmsg;

		sendEmail($_POST['email'], oc_('Committee Signup'), $mailbody, $OC_configAR['OC_notifyReviewerSignup']);

		printFooter();
		exit;
	}
}

// Display notice & form
print nl2br($OC_configAR['OC_' . $committee . 'SignUpNotice']) . '
<p><hr /></p>

<form method="post" action="' . $_SERVER['PHP_SELF'] . '" class="ocform">
<input type="hidden" name="keycode" value="' . safeHTMLstr(varValue('keycode', $_POST)) . '">
<input type="hidden" name="ocaction" value="Submit Form" />
';

oc_displayFieldSet($OC_reviewerFieldSetAR, $OC_reviewerFieldAR, $_POST);

if (oc_hookSet('committee-signup-fields')) {
	foreach ($GLOBALS['OC_hooksAR']['committee-signup-fields'] as $hook) {
		require_once $hook;
	}
}

print '<p><input type="submit" name="submit" value="' . oc_('Submit Form') . '" class="submit" /></p>';

printFooter();

?>
